package jalview.math;

import java.io.PrintStream;

public interface MatrixI
{
  /**
   * Answers the number of columns
   * 
   * @return
   */
  int width();

  /**
   * Answers the number of rows
   * 
   * @return
   */
  int height();

  /**
   * Answers the value at row i, column j
   * 
   * @param i
   * @param j
   * @return
   */
  double getValue(int i, int j);

  /**
   * Sets the value at row i, colum j
   * 
   * @param i
   * @param j
   * @param d
   */
  void setValue(int i, int j, double d);

  /**
   * Answers a copy of the values in the i'th row
   * 
   * @return
   */
  double[] getRow(int i);
  
  MatrixI copy();

  MatrixI transpose();

  MatrixI preMultiply(MatrixI m);

  MatrixI postMultiply(MatrixI m);

  double[] getD();

  double[] getE();

  void print(PrintStream ps, String format);

  void printD(PrintStream ps, String format);

  void printE(PrintStream ps, String format);

  void tqli() throws Exception;

  void tred();

  double getMaxValue();

  /**
   * Update each value in the matrix by subtracting it from the given value
   * 
   * @param val
   */
  void subtractAllFrom(double val);
}
